



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《你不知道的JavaScript》整理（一）——作用域、提升与闭包</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《你不知道的JavaScript》整理（一）——作用域、提升与闭包</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:05:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近在读一本进阶的JavaScript的书《<a href="http://download.csdn.net/download/loneleaf1/9612608" rel="external nofollow noreferrer">你不知道的JavaScript（上卷）</a>》，里面分析了很多基础性的概念。</p>
<p>可以更全面深入的理解JavaScript深层面的知识点。</p>
<h1>一、函数作用域</h1>
<p><strong>1）函数作用域</strong></p>
<p>就是作用域在一个&ldquo;Function&rdquo;里，属于这个函数的全部变量都可以在整个函数的范围内使用及复用。</p>
<div>
<pre class="prettyprint linenums">function foo(a) {<br />
  var b = 2;<br />
  function bar() {<br />
    // ...<br />
  }<br />
  var c = 3;<br />
}

bar(); // 失败<br />
console.log( a, b, c ); // 三个全都失败</pre>
</div>
<p>上面的&ldquo;foo&rdquo;函数内的几个标识符，放到函数外面访问就都会报错，<a href="http://codepen.io/strick/pen/NAkvrZ" rel="external nofollow noreferrer">查看源码</a>。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/211606/201608/211606-20160825135547257-316847299.jpg" /></p>
<p><strong>2）立即执行函数表达式</strong></p>
<p>在任意代码片段外部添加包装函数，可以将内部的变量和函数定义&ldquo;隐藏&rdquo;起来，外部作用域无法访问包装函数内部的任何内容。</p>
<p>例如上面的bar、a等几个标识符。这样能够保护变量不被污染。</p>
<p>在写插件的时候经常会用到立即执行函数表达式，为的就是保护里面的变量。</p>
<div>
<pre class="prettyprint linenums">var a = 2;<br />
(function foo() {<br />
  var a = 3;<br />
  console.log( a ); //<br />
})();<br />
console.log( a ); //</pre>
</div>
<p>&ldquo;foo&rdquo;中第一个(&nbsp; )将函数变成表达式，第二个(&nbsp; )执行了这个函数。</p>
<p>有一个专用术语：<strong>IIFE</strong>，代表立即执行函数表达式（Immediately Invoked Function Expression）；</p>
<p>1. 进阶用法是把它们当作函数调用并<strong>传递参数</strong>进去</p>
<div>
<pre class="prettyprint linenums">(function IIFE( global ) {<br />
  var a = 3;<br />
  console.log( a ); //<br />
  console.log( global.a ); //<br />
})( window );</pre>
</div>
<p>2. 一种变化的用途是<strong>倒置代码</strong>的运行顺序，在CMD或AMD项目中被广泛使用。</p>
<div>
<pre class="prettyprint linenums">(function IIFE(factory) {<br />
    factory( window );<br />
})(function def( global ) {<br />
  var a = 3;<br />
  console.log( a ); //<br />
  console.log( global.a ); //<br />
});</pre>
</div>
<h1>二、块作用域</h1>
<p>JavaScript<strong>不支持</strong>块作用域。</p>
<div>
<pre class="prettyprint linenums">for(var i=0; i&lt;10; i++) {<br />
  console.log( i );<br />
}</pre>
</div>
<p>上面的代码中的&ldquo;i&rdquo;相当于下面的</p>
<div>
<pre class="prettyprint linenums">var i;<br />
for(i=0; i&lt;10; i++) {<br />
  console.log( i );<br />
}</pre>
</div>
<p>但也有<strong>例外</strong>，&ldquo;try/catch&rdquo;，catch就是一个块作用域。</p>
<div>
<pre class="prettyprint linenums">try{<br />
  undefined(); // 执行一个非法操作来强制制造一个异常<br />
}<br />
catch(err) {<br />
  console.log( err ); // 能够正常执行！<br />
}<br />
console.log( err ); // ReferenceError: err not found</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/211606/201608/211606-20160825152338007-1145325543.jpg" /></p>
<p>ES6改变了现状，引入了新的<strong>let</strong>关键字，let关键字可以将变量绑定到所在的任意作用域中（通常是{ .. }内部）。换句话说，let为其声明的变量隐式地了所在的块作用域。</p>
<h1>三、提升</h1>
<p>函数作用域和块作用域的行为是一样的，可以总结为：任何声明在某个作用域内的变量，都将附属于这个作用域。</p>
<p><strong>1）编译与执行</strong></p>
<p>变量和函数的<strong>所有声明</strong>都会在任何代码被执行前<strong>首先被处理</strong>，可以看下面的代码事例。</p>
<div>
<pre class="prettyprint linenums">a = 2;<br />
var a;<br />
console.log(a);//</pre>
</div>
<p>这段代码等价于：</p>
<div>
<pre class="prettyprint linenums">var a;//定义声明是在编译阶段进行<br />
a = 2;//赋值声明会被留在原地等待执行阶段<br />
console.log(a);</pre>
</div>
<p><strong>2）函数优先</strong></p>
<p>函数会<strong>首先</strong>被提升，<strong>然后</strong>才是变量。</p>
<div>
<pre class="prettyprint linenums">foo(); //<br />
var foo;<br />
function foo() {<br />
  console.log( 1 );<br />
}<br />
foo = function() {<br />
  console.log( 2 );<br />
};</pre>
</div>
<p>var foo函数表达式尽管出现在function foo()的声明之前，但它是<strong>重复的声明</strong>（因此被<strong>忽略</strong>了），因为函数声明会被提升到普通变量之前。</p>
<p>而上面的代码相当于：</p>
<div>
<pre class="prettyprint linenums">function foo() {<br />
  console.log( 1 );<br />
}<br />
foo(); //<br />
foo = function() {<br />
  console.log( 2 );<br />
};</pre>
</div>
<h1>四、闭包</h1>
<p><strong>1）定义</strong></p>
<p>当函数可以<strong>记住并访问</strong>所在的作用域时，就产生了闭包，即使函数是在当前<strong>作用域之外执行</strong>。</p>
<div>
<pre class="prettyprint linenums">function foo() {<br />
  var a = 2;<br />
  function bar() {<br />
    console.log( a );<br />
  }<br />
  return bar;<br />
}

var baz = foo();<br />
baz(); // 2 &mdash;&mdash; 这就是闭包的效果。</pre>
</div>
<p>1. 将函数&ldquo;bar&rdquo;赋值给&ldquo;baz&rdquo;，执行&ldquo;baz&rdquo;，当前作用域并不在&ldquo;bar&rdquo;的作用域，但是可以执行。</p>
<p>2. 闭包还会阻止垃圾回收，当&ldquo;foo&rdquo;执行完后，内部作用域仍然存在。这样才能让&ldquo;baz&rdquo;执行。</p>
<p><strong>2）将函数作为参数传递</strong></p>
<div>
<pre class="prettyprint linenums">function foo() {<br />
  var a = 2;<br />
  function baz() {<br />
    console.log( a ); //<br />
  }<br />
  bar( baz );<br />
}

function bar(fn) {<br />
  fn(); //这就是闭包！<br />
}</pre>
</div>
<p>把内部函数baz传递给bar，当调用这个内部函数时（fn），它涵盖的foo()内部作用域的闭包就可以观察到了，因为它能够访问a。</p>
<p>如果将函数当作第一级的<strong>值类型并到处传递</strong>，你就会看到闭包在这些函数中的应用。</p>
<p>在<strong>定时器</strong>、<strong>事件监听器</strong>、<strong>Ajax请求</strong>、<strong>跨窗口通信</strong>、<strong>Web Workers</strong>或者<strong>任何其他的异步（或者同步）任务</strong>中，只要使用了<strong>回调函数</strong>，实际上就是在使用闭包！</p>
<p><strong>3）循环和闭包</strong></p>
<div>
<pre class="prettyprint linenums">for (var i = 1; i &lt;= 5; i++) {<br />
  setTimeout(function timer() {<br />
    console.log(i);<br />
  }, i * 1000);<br />
}</pre>
</div>
<p>每次打印出来都将会是6，延迟函数的回调会在循环结束时才执行，<a href="http://codepen.io/strick/pen/GqbyxQ" rel="external nofollow noreferrer">查看源码</a>。</p>
<p>根据作用域的工作原理，实际情况是尽管循环中的五个函数是在各个迭代中分别定义的，但是它们都被封闭在一个<strong>共享的全局作用域中</strong>，因此实际上只有<strong>一个i</strong>。</p>
<p>现在用闭包来实现每次打印不同的i。</p>
<div>
<pre class="prettyprint linenums">for (var i = 1; i &lt;= 5; i++) {<br />
  (function(j) {<br />
    setTimeout(function timer() {<br />
      console.log(j);<br />
    }, j * 1000);<br />
  })(i);<br />
}</pre>
</div>
<p>IIFE会通过声明并立即执行一个函数来创建作用域。setTimeout中的回调可以记住当前的作用域，每个作用域中的参数&ldquo;j&rdquo;都是不同的。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwoy1z9.html">alias实现命令别名</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kkylj8.html">阿里云主机&lpar;aliyun-Linux&rpar; x64安装Redis详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2rvrx9.html">svn 创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15z069.html">跟着上一个tcpServer 一起来的</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z12re19.html">ECHO is off</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oner39.html">Spring 创建bean的时机</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05kl0q.html">EffectiveC&num;15--使用using和try&sol;finally来做资源清理</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x5ygg9.html">Eidtplus常用快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0kp24q.html">OleDbHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1g35dq.html">Oracle数据库常用关键字以及函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj7rwe9.html">linux的定时任务服务crond（crontab）服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ko7w09.html">property&lpar;&rpar;函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyldne9.html">20&period;QT-Qpixmap实现图片鼠标缩放&comma;鼠标拖动示例&lpar;详解&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rnkd28.html">Stream基础知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll6g0kq.html">poi excel文件名或者内容中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4pekz9.html">上台阶问题（递归，DFS）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve5rey9.html">4-51单片机ESP8266学习-AT指令&lpar;测试TCP服务器--使用串口调试助手--不连接路由器&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2ko308.html">&lowbar;&lowbar;NSArrayI removeObjectAtIndex&colon;&rsqb;&colon; unrecognized selector sent to instance</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em0nlj9.html">Git 安装及使用小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp5vek9.html">Java实现文本创建、删除、编辑内容</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/65qx2v8y.html">node-webkit 环境搭建与基础demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j0ogq5.html">&lbrack;原创&rsqb;mybatis中整合ehcache缓存框架的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnjmx8r.html">HTML kbd键盘元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdp6vqd.html">jQuery学习之路（6）- 简单的表格应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q25joq7.html">一篇文章看懂TPCx-BB（大数据基准测试工具）源码</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o1leqz.html">Xamarin&plus;Prism开发详解二：Xaml文件如何简单绑定Resources资源文件内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnnvxqr.html">Http请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7731qe.html">Java开发中的23种设计模式详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2m3w87.html">【干货分享】流程DEMO-制度发文和干部任免</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93npwq3.html">nexus 社区版3&period;0&period;2部署、访问</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
